"use strict";
var log = function(values){ try{ var args = arguments; for(var i = 0; i < args.length; i++){ console.log(args[i]); } }catch(err){ }; };
var cuppa = { debug:false };
try{ cuppa.script_path = document.currentScript.src.replace("cuppa.js", ""); }catch(err){};
// npm compatibility
    try{ module.exports = { log:log, cuppa:cuppa }; }catch(err){ }
// ready
    cuppa.ready = function(callback){
        if(document.readyState === 'complete') callback();
        else document.addEventListener('DOMContentLoaded', callback);
    };
/* return element
    ref = string
    parent = string or html node
    opts = {
        parent, target: string or element
        returnType: first, last, all
        query: true // force to use querySelector
        reverse: false // invert the element order
        invert: false // invert the element order
        not:ELements
    }
*/
    cuppa.element = function(ref, opts){
        if(!ref) return;
        opts = opts || {}
        opts.returnType = opts.returnType || "all";
        opts.query = opts.query || true;
        if(opts.target) opts.parent = opts.target;
        if(ref === "body"){
            if(opts.returnType === "first") return document.body;
            else if(opts.returnType === "last") return document.body;
            else return [document.body];
        }else if(Array.isArray(ref)){
            if(opts.returnType === "first") return ref.shift();
            else if(opts.returnType === "last") return ref.pop();
            else return ref;
        }else if(ref.toString() === "[object NodeList]" || ref.toString() === "[object HTMLCollection]"){
            ref = Array.from(ref);
            if(opts.returnType === "first") return ref.shift();
            else if(opts.returnType === "last") return ref.pop();
            else return ref;
        }else if(typeof(ref) === "object"){
            if(opts.returnType === "first") return ref;
            else if(opts.returnType === "last") return ref;
            else return [ref];
        };

        if(!opts.parent || opts.parent === "body") opts.parent = [document.body];
        if(typeof(opts.parent) === "string") opts.parent = cuppa.element(opts.parent);
        if(!Array.isArray(opts.parent)) opts.parent = [opts.parent];

        var nodes = []; if(!opts.parent) return nodes;
        for(var i = 0; i < opts.parent.length; i++){
            var t = opts.parent[i];
            var n = null;
            if(cuppa.search("#", ref) && !opts.query){
                var e = cuppa.replace(ref, "#", "");
                try{ n = t.getElementById(e); }catch(err){  }
                if(n) nodes.push(n);
            }else if(cuppa.search(".", ref) && !opts.query){
                ref = cuppa.replace(ref, "\\.", "");
                try{ n = Array.from(t.getElementsByClassName(ref)); }catch(err){  }
                if(n && n.length) nodes= nodes.concat(n);
            }else{
                try{ n = Array.from(t.querySelectorAll(ref)); }catch(err){  }
                if(n && n.length) nodes= nodes.concat(n);
            };
        };
        if(opts.not) nodes = nodes.filter(function(item){ if(item !== opts.not){ return item; }else{ return null; } });
        if(opts.reverse || opts.invert) nodes.reverse();
        if(opts.returnType === "first") return nodes.shift();
        else if(opts.returnType === "last") return nodes.pop();
        else return nodes;
    };
    cuppa.elements = function(ref, opts){
        return cuppa.element(ref, opts);
    };
// elementIndex
    cuppa.elementIndex = function(element){
        var childrens = cuppa.childrens(cuppa.parent(element));
        return childrens.indexOf(element);
    };
// new element
    cuppa.newElement = function(str){
        var parent;
        var substr = str.substr(0,3);
        if(substr === "<tr") parent = document.createElement('tbody');
        else if(substr === "<td" || substr === "<th") parent = document.createElement('tr');
        else parent = document.createElement('div');
            parent.innerHTML = str;
        return parent.firstChild;
    };
// childrens
    cuppa.childrens = function(element) {
        if(!element) return null;
        var tmp = element.childNodes;
        var childrens = [];
        for(var i = 0; i < tmp.length; i++){
            if(tmp[i].nodeType === 1) childrens.push(tmp[i]);
        };
        return childrens;
    }
// remove element
    cuppa.remove = function(ref){
        var elements = cuppa.element(ref);
        if(!elements) return;
        for(var i = 0; i < elements.length; i++){
            try{
                elements[i].parentNode.removeChild(elements[i]);
            }catch(err){
                //log("Can't remove node",elements[i]);
            };
        };
    };
// clean
    cuppa.clean = function(ref){
        ref.innerHTML = "";
    };
/* removeClass */
    cuppa.removeClass = function(elements, classes){
        elements = cuppa.element(elements);
        classes = classes.split(" ");
        for(var i = 0; i < elements.length; i++){
            for(var j = 0; j < classes.length; j++){
                elements[i].classList.remove(classes[j]);
            };
        };
    };
    cuppa.addClass = function(elements, classes){
        if(!elements) return;
        if(!classes) return;
        elements = cuppa.element(elements);
        if(!Array.isArray(classes)) classes = classes.split(" ");
        for(var i = 0; i < elements.length; i++){
            for(var j = 0; j < classes.length; j++){
                if(cuppa.trim(classes[j])){
                    elements[i].classList.add(classes[j]);
                };
            };
        };
    };
    cuppa.toggleClass = function(elements, classes){
        elements = cuppa.element(elements);
        classes = classes.split(" ");
        for(var i = 0; i < elements.length; i++){
            for(var j = 0; j < classes.length; j++){
                elements[i].classList.toggle(classes[j]);
            };
        };
    };
    cuppa.hasClass = function(element, className){
        element = cuppa.element(element)[0];
        return element.classList.contains(className);
    };
    cuppa.replaceClass = function(elements, search, replace){
        elements = cuppa.element(elements);
        for(var i = 0; i < elements.length; i++){
            elements[i].classList.remove(search);
            elements[i].classList.add(replace);
        };
    };
/* attribute */
    cuppa.attribute = function(elements, name, value, remove){
        if(!elements || !name) return;
        elements = cuppa.element(elements);
        var i;
        var element;
        if(remove){
            for(i = 0; i < elements.length; i++){
                element = elements[i];
                element.removeAttribute(name);
            };
            return;
        };
        if(value !== undefined && value !== null){
            for(i = 0; i < elements.length; i++){
                element = elements[i];
                element.setAttribute(name, value);
            };
        }else{
            try{ value = elements[0].getAttribute(name); }catch(err){}
            return value;
        };
    }; cuppa.attr = function(elements, name, value, remove){ return cuppa.attribute(elements, name, value, remove); };
/* clone element
    ref: string, element
*/
    cuppa.clone = function(ref){
        var element = cuppa.element(ref, {returnType:"first"});
        var clone = element.cloneNode(true);
        return clone;
    };

// parent / parents
    cuppa.parent = function(ref){
        if(!ref) return;
        var element = cuppa.element(ref)[0];
        if(!element) return;
        return element.parentElement;
    };
    cuppa.parents = function(ref, opts){
        opts = cuppa.mergeObjects([{reverse:false, type:""}, opts]);
        var element = cuppa.element(ref)[0];
        if(!element) return;
        var parents = [];
        if(cuppa.elementType(element) === "body") return parents;
        while (element) {
            if(element.toString() !== "[object HTMLDocument]" && element.toString() !== "[object HTMLHtmlElement]"){
                if(opts.type){
                    if(cuppa.elementType(element) === opts.type){
                        parents.push(element);
                    }
                }else{
                    parents.push(element);
                }
            };
            element = element.parentNode;
        };
        parents.shift();
        if(opts.reverse) parents = parents.reverse();
        return parents;
    };
    cuppa.parentDocument = function(){
        var ref = window.parent.document;
        if(!ref) ref = document;
        return ref;
    }
// addElement, addChild
    /*  opts = {
            prepend, start, init, target:target     // insert element inside target (first position)
            append, add, end:target              // insert element inside target (last position)
            before:target                   // insert element befor target
            after:target                    // insert element after target
        }
    */
    cuppa.addChild = function(element, opts){
        if(!element) return;
        opts = opts || {}
        var target;
        if(opts.prepend){
            target = cuppa.element(opts.prepend, {query:true, returnType:"first"} );
            cuppa.prepend(element, target);
        }else if(opts.start){
            target = cuppa.element(opts.start, {query:true, returnType:"first"} );
            cuppa.prepend(element, target);
        }else if(opts.init){
            target = cuppa.element(opts.init, {query:true, returnType:"first"} );
            cuppa.prepend(element, target);
        }else if(opts.first){
            target = cuppa.element(opts.first, {query:true, returnType:"first"} );
            cuppa.prepend(element, target);
        }else if(opts.before){
            target = cuppa.element(opts.before, {query:true, returnType:"first"} );
            cuppa.before(element, target);
        }else if(opts.after){
            target = cuppa.element(opts.after, {query:true, returnType:"first"} );
            cuppa.after(element, target);
        }else if(opts.append){
            target = cuppa.element(opts.append, {query:true, returnType:"first"} );
            cuppa.append(element, target);
        }else if(opts.add){
            target = cuppa.element(opts.add, {query:true, returnType:"first"} );
            cuppa.append(element, target);
        }else if(opts.target){
            target = cuppa.element(opts.target, {query:true, returnType:"first"} );
            cuppa.append(element, target);
        }else if(opts.end){
            target = cuppa.element(opts.end, {query:true, returnType:"first"} );
            cuppa.append(element, target);
        }else if(opts.replace){
            target = cuppa.element(opts.replace, {query:true, returnType:"first"} );
            cuppa.replaceElement(element, target);
        }else if(opts.update){
            target = cuppa.element(opts.update, {query:true, returnType:"first"} );
            cuppa.update(element, target);
        };
    };
    cuppa.addElement = function(element, opts){ cuppa.addChild(element, opts); };
    cuppa.addChildren = function(element, opts){ cuppa.addChild(element, opts); };

    cuppa.append = function(element, addToElement){
        addToElement = cuppa.element(addToElement)[0];
        if(typeof element != "object") addToElement.innerHTML = element;
        else addToElement.appendChild(element);
        cuppa.executeJS(element);
    };
    cuppa.add = function(element, addToElement){ cuppa.append(element, addToElement); };
    cuppa.prepend = function(element, addToElement){
        addToElement = cuppa.element(addToElement, {returnType:"first"});
        if(addToElement.prepend) addToElement.prepend(element);
        else addToElement.insertBefore(element, addToElement.firstChild);
        cuppa.executeJS(element);
    };
    cuppa.before = function(element, addToElement){
        addToElement.parentNode.insertBefore(element, addToElement);
        cuppa.executeJS(element);
    };
    cuppa.after = function(element, addToElement){
        addToElement.parentNode.insertBefore(element, addToElement.nextSibling);
        cuppa.executeJS(element);
    };
    cuppa.previou = function(element){
        return element.previousElementSibling;
    };
    cuppa.next = function(element){
        return element.nextElementSibling;
    };
    cuppa.replaceElement = function(element, elementToReplace){
        elementToReplace.parentNode.replaceChild(element, elementToReplace);
        cuppa.executeJS(element);
    };
    cuppa.update = function(element, updateElement){
        updateElement = cuppa.element(updateElement);
        for(var i = 0; i < updateElement.length; i++){
            var el = updateElement[i];
            el.innerHTML = "";
            cuppa.append(element, el);
        };
    };
    cuppa.executeJS = function(element){
        try{ var scripts = Array.from(element.querySelectorAll("script")); }catch(err){ };
        if(!scripts) return;
        for(var i = 0; i < scripts.length; i++){
            try{ eval(scripts[i].innerHTML); }catch(err){ };
        };
    };
    cuppa.show = function(elements, opts){
        elements = cuppa.element(elements);
        if(!elements) return;
        for(var i = 0; i < elements.length; i++){
            var element = elements[i];
            opts = cuppa.mergeObjects([{ duration:0.3, display:"block", delay:0, ease:null, height:false, callback:null}, opts]);
            window.TweenMax.killTweensOf(element);
            if(opts.height === true){
                var dim = cuppa.dim(element);
                var tl = new window.TimelineMax({onComplete:opts.callback});
                    tl.to(element, opts.duration, { height:dim.scrollHeight, ease:opts.ease});
                    tl.set(element, {height:"auto"});
            }else{
                window.TweenMax.to(element, opts.duration, { alpha:1, delay:opts.delay, display:opts.display, ease:opts.ease, onComplete:opts.callback});
            }
        }
    };
    cuppa.hide = function(element, opts){
        element = cuppa.element(element);
        if(!element) return;
        opts = cuppa.mergeObjects([{ duration:0.3, delay:0, ease:null, height:false, callback:null }, opts]);
        window.TweenMax.killTweensOf(element);
        if(opts.height === true){
            window.TweenMax.to(element, opts.duration, { height:0, delay:opts.delay, ease:opts.ease, onComplete:opts.callback });
        }else{
            window.TweenMax.to(element, opts.duration, { alpha:0, display:"none", delay:opts.delay, ease:opts.ease, onComplete:opts.callback });
        }
    };
/* nodeName  */
    cuppa.nodeType = function(element){ return  element.nodeName.toLowerCase(); };
    cuppa.elementType = function(element){ return cuppa.nodeType(element); };
/* blockade */
    cuppa.blockade = function(opts){
        if(opts === undefined) opts = {};
        if(opts.load === undefined) opts.load = true;
        if(opts.delay === undefined) opts.delay = 0;
        if(opts.opacity === undefined) opts.opacity = 1;

        if(opts.load){
            if(opts.duration === undefined) opts.duration = 0.3;
            if(opts.ease === undefined) opts.ease = window.Cubic.easeOut;
            if(opts.zIndex === "max") opts.zIndex = cuppa.maxZIndex()+1;
            if(opts.id === undefined) opts.id = cuppa.unique("blockade_");
            if(opts.className === undefined) opts.className = "blockade";
            if(opts.target === undefined) opts.target = document.body;
            cuppa.blur();
            var blockade = document.createElement('div');
                blockade.id = opts.id;
                blockade.classList.add("cu-blockade");
                if(opts.className) blockade.classList.add(opts.className);
                if(opts.personalClass) blockade.classList.add(opts.personalClass);
                blockade.style.opacity = 0;
                if(opts.zIndex) blockade.style.zIndex = opts.zIndex;
                window.TweenMax.to(blockade, opts.duration, {delay:opts.delay, alpha: opts.opacity, ease:opts.ease});
                cuppa.addElement(blockade, opts);
        }else{
            if(opts.duration === undefined) opts.duration = 0.2;
            if(opts.ease === undefined) opts.ease = window.Cubic.easeIn;
            if(opts.removeType === undefined) opts.removeType = "last";  // last (default), first, all
            if(opts.className === undefined) opts.className = ".cu-blockade";
            // get blockades
                var blockades;
                if(opts.id) blockades = cuppa.element("#"+opts.id, {returnType:"first", target:opts.target});
                else blockades = cuppa.element(opts.className, {returnType:opts.removeType, target:opts.target});
            if(!Array.isArray(blockades)) blockades = [blockades];
            for(var i = 0; i < blockades.length; i++){
                try{
                    window.TweenMax.to(blockades[i], opts.duration, {delay:opts.delay, alpha:0, ease:opts.ease, onCompleteParams:[blockades[i]], onComplete:function(item){ cuppa.remove(item); } })
                }catch(err){ };
            }
        }
    }
// blockade screen
    cuppa.blockadeScreen = function(value){
        if(value === undefined) value = true;
        if(value) cuppa.blockade({duration:0, opacity:0, zIndex:"max", personalClass:"cu-blockade-screen"});
        else cuppa.blockade({load:false, className:".cu-blockade-screen", duration:0, removeType:"all", delay:0.2});
    };
// get iframe
    cuppa.getIframe = function(){
        return window.frameElement;
    };
/* charger */
    cuppa.charger = function(data){
        if(data === undefined) data = {};
        if(data.load === undefined) data.load = true;
        if(data.name === undefined && data.load) data.name = "charger-small";
        if(data.name === undefined && !data.load && !data.removeAll) data.name = "#charger-small";
        if(data.name === undefined && !data.load && data.removeAll) data.name = ".charger-small";
        if(data.duration === undefined) data.duration = 0;
        if(data.delay === undefined) data.delay = 0;
        if(data.target === undefined) data.target = "body";
        if(data.uniqueClass === undefined) data.uniqueClass = data.name+"_"+Math.ceil(Math.random()*999999);
        if(data.personalClass === undefined) data.personalClass = "";
        if(data.zIndex === undefined) data.zIndex = cuppa.maxZIndex()+1;
        // remove
        if(!data.load){
            var chargerToRemove;
            if(data.last) chargerToRemove = cuppa.element(data.name, {returnType:"last"});
            else if(data.first) chargerToRemove = cuppa.element(data.name, {returnType:"first"});
            else chargerToRemove = cuppa.element(data.name);
            try{
                window.TweenMax.to(chargerToRemove, data.duration, {delay:data.delay, alpha:0, onComplete:function(){ cuppa.remove(chargerToRemove); } });
            }catch(err){ }
            return null;
        }
        // load
        var charger = document.createElement("div");
            charger.id = data.name;
            cuppa.addClass(charger, [data.name, data.personalClass, data.uniqueClass]);
            cuppa.css(charger,{opacty:0, display:"block"});
        if(data.zIndex) cuppa.css(charger,{'z-index':data.zIndex});
        window.TweenMax.to(charger, data.duration, {delay:data.delay, alpha:1});
        cuppa.append(charger,data.target);
        return charger;
    };

// noscroll
    cuppa.noscroll = function(value, all){
        if(value === undefined) value = true;
        if(all === undefined) all = false;
        if(value){
            if(all) document.body.classList.add("noscroll-all");
            else document.body.classList.add("noscroll");
        }else{
            document.body.classList.remove("noscroll");
            document.body.classList.remove("noscroll-all");
        };
    };
// text
    cuppa.text = function(elements, value){
        if(!elements) return;
        elements = cuppa.element(elements);
        if(value === undefined && elements[0]){
            return elements[0].innerHTML;
        }
        for(var i = 0; i < elements.length; i++){
            elements[i].innerHTML = value;
        };
    };
// requiereJS / IncludeJS / loadJS
    cuppa.requireJSDirectory = {};
    cuppa.loadedJS = 0;
    cuppa.requiereJS = function(paths, callback, progress, type, opts){
        if( typeof(paths) == "string") paths = [paths];
        if(!type) type = 'text/javascript';
        opts = cuppa.mergeObjects([{target:document.head}, opts]);
        cuppa.loadedJS = 0;
        var head = document.getElementsByTagName('head')[0];
        for(var i = 0; i < paths.length; i++){
            var path = paths[i];
            if(cuppa.requireJSDirectory[path]){
                onComplete();
            }else{
                cuppa.requireJSDirectory[path] = true;
                var element = document.createElement('script');
                    element.src = path;
                    element.type = type;
                    element.onload = onComplete;
                    opts.target.appendChild(element);
            };
        };
        function onComplete(e){
            cuppa.loadedJS++;
            if(cuppa.loadedJS >= paths.length && callback){
                callback(cuppa.loadedJS, paths.length);
            }else if(progress){
                progress(cuppa.loadedJS, paths.length);
            };
        };
    };
    cuppa.includeJS = function(paths, callback, progress){ cuppa.requiereJS(paths, callback, progress); };
    cuppa.loadJS = function(paths, callback, progress){ cuppa.requiereJS(paths, callback, progress); };
// requiereCSS / IncludeCSS / loadCCS
    cuppa.requireCSSDirectory = {};
    cuppa.loadedCSS = 0;
    cuppa.requiereCSS = function(paths, callback, progress, opts){
        if( typeof(paths) == "string") paths = [paths];
        opts = cuppa.mergeObjects([{target:document.head}, opts]);
        cuppa.loadedCSS = 0;
        for(var i = 0; i < paths.length; i++){
            var path = paths[i];
            if(cuppa.requireCSSDirectory[path]){
                onComplete();
            }else{
                cuppa.requireCSSDirectory[path] = true;
                var element = document.createElement('link');
                    element.rel = "stylesheet";
                    element.type = "text/css";
                    element.href = path;
                    element.onload = onComplete;
                    opts.target.appendChild(element);
            };
        };
        function onComplete(e){
            cuppa.loadedCSS++;
            if(cuppa.loadedCSS >= paths.length && callback){
                callback(cuppa.loadedCSS, paths.length);
            }else if(progress){
                progress(cuppa.loadedCSS, paths.length);
            };
        };
    };
    cuppa.includeCSS = function(paths, callback, progress){ cuppa.requiereCSS(paths, callback, progress); };
    cuppa.loadCSS = function(paths, callback, progress){ cuppa.requiereCSS(paths, callback, progress); };

// requireComponent / IncludeComponent / loadComponents
    cuppa.requireComponentDirectory = {};
    cuppa.loadedComponents = 0;
    cuppa.requireComponent = function(paths, opts){
        if( typeof(paths) == "string") paths = [paths];
        opts = cuppa.mergeObjects([{callback:null, progress:null, plainComponent:true, reload:false, target:document},opts])
        cuppa.loadedComponents = 0;
        for(var i = 0; i < paths.length; i++){
            var path = paths[i];
            if(cuppa.requireComponentDirectory[path] && !opts.reload){
                onComplete();
            }else{
                cuppa.requireComponentDirectory[path] = true;
                cuppa.processComponent(path, {callback:onComplete, plainComponent:opts.plainComponent, target:opts.target});
            };
        };
        function onComplete(e){
            cuppa.loadedComponents++;
            if(opts.progress){
                opts.progress(cuppa.loadedComponents, paths.length);
            };
            if(cuppa.loadedComponents >= paths.length && opts.callback){
                opts.callback(cuppa.loadedComponents, paths.length);
            };
        };
    };
    cuppa.includeComponent = function(paths, opts){ cuppa.requireComponent(paths, opts); };
    cuppa.loadComponent = function(paths, opts){ cuppa.requireComponent(paths, opts); };
    cuppa.component = function(paths, opts){ cuppa.requireComponent(paths, opts); };
    cuppa.components = function(paths, opts){ cuppa.requireComponent(paths, opts); };

// load Component
    cuppa.processComponent = function(url, opts){
        opts = cuppa.mergeObjects([{callback:null, plainComponent:true, target:document},opts])
        cuppa.ajax(url,{method:"GET"}, function(result){
            var oldElement = opts.target.getElementById("component_"+url);
            if(oldElement) cuppa.remove(oldElement);
            if(!result) {
                if(opts.callback) opts.callback(url);
                return;
            };
            if(opts.plainComponent){
                if(!cuppa.componentListContainer){
                    cuppa.componentListContainer = opts.target.createElement('div');
                    cuppa.componentListContainer.id = "component_list_container";
                    cuppa.componentListContainer.style.display = "none";
                    cuppa.append(cuppa.componentListContainer, opts.target.body);
                }
                var components = opts.target.getElementById("component-list");
                var div = opts.target.createElement('div');
                    div.id = "component_"+url;
                    div.innerHTML = result;
                    div.style.display = "none";
                cuppa.append(div, cuppa.componentListContainer);
                if(opts.callback) opts.callback(url);
                return;
            };
            var template = result.split("<template>")[1];
                template = template.split("</template>")[0];
                template = cuppa.replace(template,"\n","");
                template = cuppa.trim(template);
            var script = result.split("<script>")[1];
                script = script.split("</script>")[0];
                script = cuppa.trim(script);
                script = "window.Class = "+script;
                script = script.replace("super();", "super(); this.processComponent();");
                try{ script = eval(script); }catch(err){ };
                if(typeof script === "string") return;
                script.prototype.template = cuppa.newElement(template);
                script.prototype.processComponent = function(){
                    var temp = this.template.cloneNode(true);
                    /*
                    if(this.getAttribute("shadow-dom") != null){
                        this.html = this.attachShadow({mode: 'open'});
                        this.html.appendChild(temp);
                        cuppa.nodes(this.html, this.html);
                        this.state = new cuppa.state(this.html);
                    }else{
                    */
                        this.appendChild(temp);
                        cuppa.nodes(this, this);
                        this.state = new cuppa.state(this);
                    //}
                };
            var fileDesc = cuppa.fileDescription(url);
            customElements.define(fileDesc.name, script);
            if(opts.callback) opts.callback(url);
        });
    };

/* setNodes
        html: html to extract the nodes
        addTo: Object where we want to add the nodes
*/
    cuppa.nodes = function(html, addTo){
        var nodes = {}
        var elements = Array.from(html.querySelectorAll("[id]"));
        for(var i = 0; i < elements.length; i++){
            if(addTo) addTo[elements[i].id] = elements[i];
            else nodes[elements[i].id] = elements[i];
        }

        if(addTo) addTo["rootHtml"] = html;
        else nodes["rootHtml"] = html;

        return nodes;
    };
/* set state
    var states = new cuppa.state(html);
        states.set({name:'Tufik', age:18})
        states.set("name",value)
        states.set("name",{value:'Tufik', addClass:'classToAdd'})
        states.set("name",{state:'state2', removeClass:'classToRemove'})
        states.set("name",{state:'state2', css:{background:'#F00'}})

* */
    cuppa.state = function(html){
        if(typeof html == "string") html = cuppa.newElement(html);
        this.html = html ||  document.body;
        this.data = {};
        this.set = function(name, opts){
            // if object
            if(typeof name === "object"){
                this.tmp = name;
                Object.keys(this.tmp).forEach(function(key) {
                    var valueTmp = {value:this.tmp[key]};
                    valueTmp = cuppa.mergeObjects([valueTmp, opts]);
                    this.set(key, valueTmp);
                }.bind(this));
                return;
            }
            if(typeof opts === "string") opts = {value:opts};
            // other data
            opts = opts || {};
            opts.global = opts.global || false;
            opts.byId = opts.byId || false;
            opts.addClass = opts.addClass || "";
            opts.removeClass = opts.removeClass || "";
            opts.css = opts.css || null;
            opts.addCSS = opts.addCSS || null;
            opts.keep = opts.keep || false;
            if(!opts.keep) this.data[name] = opts.value;
            // get items
            var items = [];
            if(typeof name == "object") items = [name];
            else if(opts.global){ items = Array.from(document.body.querySelectorAll("[state="+name+"]"));
            }else{
                if(opts.byId && this.html[name]) items = [this.html[name]];
                else items = Array.from(this.html.querySelectorAll("[state="+name+"]"));
            }
            if(!items || !items.length) return;
            //++ change value / state
            var i; var item;
            if(opts.value !== undefined){
                for(i = 0; i < items.length; i++){
                    item = items[i];
                    if(item.value !== undefined) item.value = opts.value;
                    else if(cuppa.nodeType(item) === "img") item.src = opts.value;
                    else if(item.getAttribute("state-update") === "background") cuppa.css(item,{'background-image':'url('+opts.value+')'});
                    else item.innerHTML = opts.value;
                }
            }
            if(opts.state){
                for(i = 0; i < items.length; i++){
                    item = items[i];
                    if(item.value) item.value = item.getAttribute(opts.state);
                    if(items.nodeName && items.nodeName.toLowerCase() === "img") item.src = item.getAttribute(opts.state);
                    else item.innerHTML = item.getAttribute(opts.state);
                }
            }
            //--
            // addClass
            if(opts.addClass) this.addClass(name, opts.addClass, opts.global);
            // removeClass
            if(opts.removeClass) this.removeClass(name, opts.removeClass, opts.global);
            // addCSS
            if(opts.css) this.addCSS(name, opts.css, opts.global);
            if(opts.addCSS) this.addCSS(name, opts.addCSS, opts.global);
            // blockade
            if(opts.blockade === true) cuppa.blockadeScreen(true);
            if(opts.blockade === false) cuppa.blockadeScreen(false)
            // blockade
            if(opts.disable === true) cuppa.addClass(items,"disabled");
            if(opts.disable === false) cuppa.removeClass(items,"disabled");
        };
        this.get = function(name, opts){
            opts = opts || {};
            opts.global = opts.global || false;
            var value = "";
            if(opts.global) value = document.body.querySelector("[state="+name+"]").innerHTML;
            else value = this.html.querySelector("[state="+name+"]").innerHTML;
            return value;
        };
        this.addClass = function(name, value, global){
            value = value.split(",");
            var elements = [];
            if(global) elements = Array.from(elements.querySelectorAll("[state="+name+"]"));
            else elements = Array.from(this.html.querySelectorAll("[state="+name+"]"));
            for(var i = 0; i < elements.length; i++){
                for(var j = 0; j < value.length; j++){
                    elements[i].classList.add(cuppa.trim(value[j]));
                };
            };
        };
        this.removeClass = function(name, value, global){
            value = value.split(",");
            var elements = [];
            if(global) elements = Array.from(elements.querySelectorAll("[state="+name+"]"));
            else elements = Array.from(this.html.querySelectorAll("[state="+name+"]"));
            for(var i = 0; i < elements.length; i++){
                for(var j = 0; j < value.length; j++){
                    elements[i].classList.remove(cuppa.trim(value[j]));
                };
            };
        };
        this.addAttr = function(name, attr, value, global){
            var elements = [];
            if(global) elements = Array.from(elements.querySelectorAll("[state="+name+"]"));
            else elements = Array.from(this.html.querySelectorAll("[state="+name+"]"));
            for(var i = 0; i < elements.length; i++){ elements[i].setAttribute(attr, value); };
        };
        this.removeAttr = function(name, attr, global){
            var elements = [];
            if(global) elements = Array.from(elements.querySelectorAll("[state="+name+"]"));
            else elements = Array.from(this.html.querySelectorAll("[state="+name+"]"));
            for(var i = 0; i < elements.length; i++){ elements[i].removeAttribute(attr); };
        };
        // css = { property:value, property:value }
        this.addCSS = function(name, css, global){
            var elements = [];
            if(global) elements = Array.from(elements.querySelectorAll("[state="+name+"]"));
            else elements = Array.from(this.html.querySelectorAll("[state="+name+"]"));
            for(var i = 0; i < elements.length; i++){
                for (var prop in css) { elements[i].style[prop] = css[prop]; }
            };
        };
        this.css = function(name, css, global){
            this.addCSS(name, css, global);
        };
        this.setData = function(data){
            this.tmp = data;
            Object.keys(this.tmp).forEach(function(key) {
                this.set(key, {value:this.tmp[key]});
            }.bind(this));
        };
    };

/* bindAll */
    cuppa.bindAll = function(element, isFunction){
        var propertyNames = Object.getOwnPropertyNames(Object.getPrototypeOf(element));
        if(isFunction)  propertyNames = Object.keys(element);
        for(var i = 0; i < propertyNames.length; i++){
            if(typeof element[propertyNames[i]] == "function"){
                element[propertyNames[i]]= element[propertyNames[i]].bind(element);
            };
        };
    };

/* cuppa.componentProcess */
    cuppa.componentAdjust = function(element, templateID){
        const currentDocument = (document.currentScript) ? document.currentScript.ownerDocument : document;
        let templateRef = currentDocument.getElementById(templateID);
        let template = templateRef.content.cloneNode(true);
        cuppa.attr(element, "style", cuppa.attr(templateRef, "style"));
        cuppa.attr(element, "class", cuppa.attr(templateRef, "class"));
        element.appendChild(template);
        cuppa.nodes(element, element);
        cuppa.bindAll(element);
    };
