/* Get percent betwen 2 range */
    cuppa.percent = function(n, min, max, invert){
        var percent = (n-min)/(max-min);
        if(percent < 0) percent = 0;
        else if(percent > 1) percent = 1;
        if(invert) percent = 1-percent;
        return percent
    };
/* random */
    cuppa.random = function(min, max, percent) {
        var rand = percent || Math.random();
        return Math.floor(rand * (max - min)) + min;
    };
/* randomString */
    cuppa.randomString = function(length, characters){
        length = length || 5;
        characters = characters ||  "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        var text = "";
        for( var i=0; i < length; i++ ){
            text += characters.charAt(Math.floor(Math.random() * characters.length));
        }
        return text;
    };
/* random color
        alpha: 'random', number (0-1)
*/
    cuppa.randomColor = function(alpha){
        if(alpha == undefined) alpha = Math.random();
        var color =  "rgba("+Math.floor(Math.random()*255)+","+Math.floor(Math.random()*255)+","+Math.floor(Math.random()*255)+","+alpha+")";
        return color;
    };
/* Get new dimensions
    force:width,height
*/
    cuppa.newDim = function(width, height, new_width, new_height, invert, force){ return cuppa.newDimensions(width, height, new_width, new_height, invert, force); }
	cuppa.newDimensions = function(width, height, new_width, new_height, invert, force) {
		if(!invert) invert = false;
        width = parseFloat(width); height = parseFloat(height); new_width = parseFloat(new_width); new_height = parseFloat(new_height);
		var porcent = 1 + ((new_width - width) / width);
        if(force == "width"){
            var porcent = 1 + ((new_width - width) / width);
                new_width = width*porcent;
				new_height = height*porcent;
                return {width:new_width, height:new_height, scale:porcent}
        }else if(force == "height"){
            var porcent = 1 + ((new_height - height) / height);
                new_width = width*porcent;
                new_height = height*porcent;
                return {width:new_width, height:new_height, scale:porcent}
        }

		if(!invert){
			if(height*porcent >= new_height){
				new_width = width*porcent;
				new_height = height*porcent;
			}else{
				porcent = 1 + ((new_height - height)/height);
				new_width = width*porcent;
				new_height = height*porcent;
			}
		}else{
			if(height*porcent <= new_height){
				new_width = width*porcent;
				new_height = height*porcent;
			}else{
				porcent = 1 + ((new_height - height)/height);
				new_width = width*porcent;
				new_height = height*porcent;
			}
		}
		return {width:new_width, height:new_height, scale:porcent}
	};
  /* Get real dimentions
   *  Recomendable add all inner element inside the container without scroll "wrapper"
   */
    cuppa.dim = function(element, opts){ return cuppa.dimentions(element, opts); }
    cuppa.dimentions = function(element, opts){
        if(!opts) opts = {}
        if(element == undefined || element == "body" ) element = document.body;
        var value = {width:0, height:0, x:0, y:0 };
        // change parents elements
            var parents = cuppa.parents(element);
            var tmpParents = new Array();
            for(var i = 0; i < parents.length; i++){ if( cuppa.css(parents[i], "display") == "none" ) tmpParents.push(parents[i]); }
            if(cuppa.css(element, "display") == "none") tmpParents.push(element);
            cuppa.css(tmpParents, {display:"block", visibility:"hidden"});

            var clientRect = element.getBoundingClientRect();
            var scrollPos = cuppa.scrollPosition(opts.scrollRef);
            var style = getComputedStyle(element);
        // x,y (position from init of document) - not work
            value.x = (window.scrollX) ? clientRect.left + window.scrollX :  clientRect.left + window.pageXOffset;
            value.y = (window.scrollY) ? clientRect.top + window.scrollY : clientRect.top + window.pageYOffset;
        // x2,y2 (position from parent element) - work
            value.x2 = element.offsetLeft;
            value.y2 = element.offsetTop;
        // x3,y3 (fixed position on window) - work
            value.x3 = clientRect.left;
            value.y3 =  clientRect.top;
        // x4,y4 (position from parent element + scroll position) - work
            value.x4 = value.x + scrollPos.x;
            value.y4 =  value.y + scrollPos.x;
        // dimentions, + border, + padding
            value.width = element.offsetWidth;
            value.height = element.offsetHeight;
        // dimentions, - border, - padding
            value.width2 = element.clientWidth - parseFloat(style.paddingLeft) - parseFloat(style.paddingRight);
            value.height2 = element.clientHeight - parseFloat(style.paddingTop) - parseFloat(style.paddingBottom);
        // dimentions, - border
            value.width3 = element.clientWidth;
            value.height3 = element.clientHeight;
        // dimentions, + border, + padding, + margin
            value.width4 = element.offsetWidth + parseFloat(style.marginLeft) + parseFloat(style.marginRight);
            value.height4 = element.offsetHeight + parseFloat(style.marginTop) + parseFloat(style.marginBottom);
        // scroll dimensions
            value.scrollWidth = element.scrollWidth;
            value.scrollHeight = element.scrollHeight;
        // client dimentions
            value.clientWidth = element.clientWidth;
            value.clientHeight = element.clientHeight;
        // return parents to default
            cuppa.css(tmpParents, {display:"none", visibility:"visible"});
        return value;
    };
// width / height
    cuppa.width = function(outer){
        if(outer) return window.innerWidth;
        else return document.documentElement.clientWidth;
    }
    cuppa.height = function(outer){
        if(outer) return window.innerHeight;
        else return document.documentElement.clientHeight;
    }
// Get arc params
    cuppa.arcParams = function(x, y, radius, startAngle, endAngle){
        function polarToCartesian(centerX, centerY, radius, angleInDegrees) {
            var angleInRadians = (angleInDegrees-90) * Math.PI / 180.0;
            return {
                x: centerX + (radius * Math.cos(angleInRadians)),
                y: centerY + (radius * Math.sin(angleInRadians))
            };
        };
        var start = polarToCartesian(x, y, radius, endAngle);
        var end = polarToCartesian(x, y, radius, startAngle);
        var arcSweep = endAngle - startAngle <= 180 ? "0" : "1";
        var d = [
            "M", start.x, start.y,
            "A", radius, radius, 0, arcSweep, 0, end.x, end.y,
            "L", x,y,
            "L", start.x, start.y
        ].join(" ");
        return d;
    };
// Get the oposite dimention of a triangle rectangle
    cuppa.getOpositeDimention = function(longitude, angle){
        angle = (angle/180)*Math.PI;
        var A = angle;
        var b = longitude;
        var C = 90;
        var B = 180-C-Math.abs(A);
        var c = b/Math.cos(A);
        var a =b*Math.tan(A);
        return a;
    };
