
/* replace in range
    opts = {
        first: false,
        range: [init_string, end_string],
        first_range: false
        split: false;
    }
*/
cuppa.replace = function(string, search, replace, opts){
        if(!string) return "";
        opts = opts || {};
        if(opts.range){
            var c_temp1 = string.split(opts.range[0]);
            if(c_temp1.length <= 1 ) return string;
            for(var i = 0; i < c_temp1.length; i++){
                var c_temp2 = c_temp1[i].split(opts.range[1]);
                if(c_temp2.length > 1){
                    if(opts.first){
                        if(opts.split) c_temp2[0] = cuppa.replaceSplit(c_temp2[0], search, replace);
                        else c_temp2[0] = c_temp2[0].replace(search, replace);
                    }else{
                        if(opts.split) c_temp2[0] = cuppa.replaceSplit(c_temp2[0], search, replace);
                        else c_temp2[0] = c_temp2[0].replace(new RegExp(search, 'g'), replace);
                    }
                    c_temp1[i] = c_temp2.join(opts.range[1]);
                    if(opts.first_range) break;
                }
            }
            string = c_temp1.join(opts.range[0]);
        }else{
            if(opts.first){
                if(opts.split) string = cuppa.replaceSplit(string, search, replace);
                else string = string.replace(search, replace);
            }else{
                if(opts.split) string = cuppa.replaceSplit(string, search, replace);
                else string = string.replace(new RegExp(search, 'g'), replace);
            }
        };
        return string;
    };
    cuppa.replaceSplit = function(string, search, replace){
        return string.split(search).join(replace);
    };
/* Unique value */
    cuppa.unique = function(addToInit, dateFormat){
        var value = "";
        if(dateFormat){
            value =  new Date().toISOString() + "-" + Math.round(Math.random()*9999);
            value = cuppa.replace(value,":","-");
            value = cuppa.replace(value,"\\.","-");
        }else{
            value = new Date().valueOf()+Math.round(Math.random()*9999);
        }
        if(addToInit) value = addToInit + value;
        return value;
    };
/* generate UUID */
    cuppa.UUID = function(){
        var d = new Date().getTime();
        if (typeof performance !== 'undefined' && typeof performance.now === 'function'){ d += performance.now(); }
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = (d + Math.random() * 16) % 16 | 0;
            d = Math.floor(d / 16);
            return (c === 'x' ? r : (r & 0x3 | 0x8)).toString(16);
        });
    };
/* Method Trim() */
	cuppa.trim = function(string){
	   if(string) return string.replace(/^\s+|\s+$/g, '');
       else return "";
	};
/* Validate if a string is email, Return true of false */
	cuppa.email = function(value){
	   var emailExpression = /^[a-z 0-9][\w.-]+@\w[\w.-]+\.[\w.-]*[a-z][a-z]$/i;
	   return emailExpression.test(cuppa.trim(value));
	};
/* Validate if a string is a url, Return true of false */
    cuppa.url = function(str) {
        var regexp = /[-a-zA-Z0-9@:%_+.~#?&//=]{2,256}\.[a-z]{2,4}\b(\/[-a-zA-Z0-9@:%_+.~#?&//=]*)?/gi;
        return regexp.test(str);
    }
/* Delete more of two spaces */
	cuppa.deleteDoubleSpaces = function(value){
		var valueExpression = /\s+/gi;
		return value.replace(valueExpression, " ");
	};

/* Remove break lines*/
    cuppa.removeBreakLines = function(value){
        if(!value) return value;
        return value.replace(/(\r\n|\n|\r)/gm, "");
    };
/* Search a word inside of a string. Return true or false */
	cuppa.searchWord = function(word, string) {
        if(!string) return false;
		word = word.toLowerCase();
		string = string.toLowerCase();
		var result = string.indexOf(word);
		if (result === -1) return false;
		else return true;
	};
    cuppa.search = function(word, string) { return cuppa.searchWord(word, string); };
/* String like, similar to LIKE in MySQL */
    cuppa.stringLike = function(string, like){
        if(!string) return false;
        if(string.indexOf(like) >= 0) return true;
        else return false;
    };
    cuppa.likeString = function(string, like){ return cuppa.stringLike(string, like); }
/* Capitalize */
    cuppa.capitaliseFirstLetter = function(string){
        if(!string) string = '';
        string = string.toLocaleLowerCase();
        return string.charAt(0).toUpperCase() + string.slice(1);
    };
    cuppa.capitaliseAllWords = function(str){
        if(!str) str = '';
        str = str.toLocaleLowerCase();
        var pieces = str.split(" ");
        for ( var i = 0; i < pieces.length; i++ ){
            var j = pieces[i].charAt(0).toUpperCase();
            pieces[i] = j + pieces[i].substr(1);
        }
        return pieces.join(" ");
    };
/* Convert number a money format: 100,000.15 */
    cuppa.numberToMoney = function(value, decimals, decimalSeparator) {
        if(decimals === undefined) decimals = 0;
        value = parseFloat(value).toFixed(decimals);
        value = String(value);
        if (Number(value) === 0 || isNaN(value) || value === "") return "0";
        if (decimalSeparator === undefined) decimalSeparator = ".";
        var moneyFormat = "";
        var result;
        var arrayData;
        var floatData;
        var i;
        if(decimalSeparator === "."){
    		arrayData = value.split(".");
            floatData = ""; if (arrayData.length > 1) floatData = "." + arrayData[arrayData.length - 1];
            arrayData = arrayData[0].split("");
            arrayData.reverse();
    		for (i = arrayData.length - 1; i >= 0; i--) {
    			moneyFormat += arrayData[i];
    			if (i > 0) {
    				result = (i / 3);
    				result = result - Math.floor(i / 3);
    				if (Number(result) === 0 && arrayData[i] !== "-") {
    					moneyFormat += ",";
    				}
    			}
    		}
        }else if(decimalSeparator === ","){
            arrayData = value.split(",");
    		floatData = ""; if (arrayData.length > 1) floatData = "," + arrayData[arrayData.length - 1];
            arrayData = arrayData[0].split("");
            arrayData.reverse();
    		for (i = arrayData.length - 1; i >= 0; i--) {
    			moneyFormat += arrayData[i];
    			if (i > 0) {
    				result = (i / 3);
    				result = result - Math.floor(i / 3);
    				if (Number(result) === 0 && arrayData[i] !== "-") {
    					moneyFormat += ".";
    				}
    			}
    		}
        }
        moneyFormat += floatData;
        if(moneyFormat == 0) return "";
		return  moneyFormat;
	};
/* Convert money format to number: 100000.15 */
    cuppa.moneyToNumber = function(value, decimalSeparator){
        value = String(value);
        if (decimalSeparator === undefined) decimalSeparator = ".";
        if(decimalSeparator === "."){
            value = cuppa.replace(value, ",", "")
        }else{
            value = cuppa.replace(value, ".", "");
            value = cuppa.replace(value, ",", ".");
        }
        value = parseFloat(value);
        if (value === 0 || isNaN(value) || value === "") return "";
        return value;
    };
/* Convert url string to object */
    cuppa.urlToObject = function(string, urlDecode){
        if(urlDecode === undefined) urlDecode = true;
        if(!string) string = cuppa.getPath();
        if(string.indexOf("?") !== -1) string = string.substr(string.indexOf("?")+1);
        if(string.indexOf("#") !== -1) string = string.substr(string.indexOf("#")+1);
        var data = string.split("&");
        var object = {};
        if(data.length < 1) return null;
        for(var i = 0; i < data.length; i++){
            var item =  data[i].split("=");
            try{
                if(urlDecode) item[1] = cuppa.urlEncode(item[1]);
                if(item[0]) object[item[0]] = item[1];
            }catch(err){}
        }
        if(!Object.keys(object).length) return null;
        return object;
    };
/* Get UrlFriendly
        Example: news/article-news-1
    */
    cuppa.urlFriendly = function(str, max, spaceChar) {
        if(spaceChar == undefined) spaceChar = "-";
        if(!str) return;
        if (max === undefined) max = 500;
        var a_chars = [];
        a_chars.push(["a",/[áàâãªÁÀÂÃ]/g]);
        a_chars.push(["e",/[éèêÉÈÊ]/g]);
        a_chars.push(["i",/[íìîÍÌÎ]/g]);
        a_chars.push(["o",/[òóôõÓÒÔÕ]/g]);
        a_chars.push(["u",/[úùûÚÙÛ]/g]);
        a_chars.push(["c",/[çÇ]/g]);
        a_chars.push(["n",/[Ññ]/g]);
        a_chars.push(["-",/[.]/g]);
        a_chars.push(["",/['"\\()[\]/*++¿?#:;@$º&*^·’,.!¡%=+|]/g]);
        for(var i=0; i < a_chars.length; i++){
            str = str.replace(a_chars[i][1], a_chars[i][0]);
        }
        str = str.replace(/\s+/g,spaceChar).replace(/_+/g,spaceChar).toLowerCase().replace(/-{2,}/g,spaceChar).replace(/(^\s*)|(\s*$)/g, '').substr(0,max);
        str = str.replace(/[^a-zA-Z0-9_ -]/g, "");
        str = str.replace(/[\-]/g, spaceChar);
        return str;
    };
    cuppa.cleanString = function(str, max, spaces){ return cuppa.urlFriendly(str, max, spaces); };
    cuppa.removeSpecialCharacters = function(str, max, spaces){ return cuppa.urlFriendly(str, max, spaces); };
/* Get Path vars Vars
    Exampe: news/article-news-1
            Return: Array('news','article-news-1')
*/
    cuppa.pathVars =  function(str, number_return){
        if(number_return === undefined) number_return = false;
        str = str.split("/");
        var array = [];
        for(var i = 0; i < str.length; i++){
            if(str[i]){
                str[i] = cuppa.trim(str[i]);
                if(number_return){
                    var number = parseInt(str[i]);
                    if(number) str[i] = number;
                }
                array.push(str[i]);
            }
        }
        return array;
    };
/* Get UTF8 Encode */
    cuppa.utf8Encode = function(string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";
		for (var n = 0; n < string.length; n++) {
			var c = string.charCodeAt(n);
			if (c < 128) {
				utftext += String.fromCharCode(c);
			}else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
		}
		return utftext;
	};
/* Get UTF8 Decode */
    cuppa.utf8Decode = function(utftext) {
		var string = "";
		var i = 0;
		var c, c2, c3 = 0;
		while ( i < utftext.length ) {
			c = utftext.charCodeAt(i);
			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			} else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			} else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
		}
		return string;
    };
/* remove html tags */
    cuppa.removeTags = function(cleanText){
        if(!cleanText) cleanText = "";
        cleanText = cleanText.replace(/<\/?[^>]+(>|$)/g, "");
        return cleanText;
    };
/* Cut text */
    cuppa.cutText = function(delimiter, text, lenght, string_to_end, delimiter_forced, remove_tags){
        if(text === undefined) text = "";
        if(delimiter === undefined) delimiter = " ";
        if(lenght === undefined) lenght = 200;
        if(string_to_end === undefined) string_to_end = "";
        if(delimiter_forced === undefined) delimiter_forced = false;
        if(remove_tags === undefined) remove_tags = false;
        if(remove_tags) text = cuppa.removeTags(text);

        if(delimiter_forced){
            text = text.substr(0, lenght);
            if(cuppa.strrpos(text, delimiter) !== false) text = cuppa.trim(text.substr(0, cuppa.strrpos(text, delimiter)));
            text += string_to_end;
        }else if(text.length > lenght ){
            text = text.substr(0, lenght);
            if(cuppa.strrpos(text, delimiter) !== false) text = cuppa.trim(text.substr(0, cuppa.strrpos(text, delimiter)));
            text += string_to_end;
        }
        return text;
    };
/* Strpost*/
    cuppa.strpos = function(haystack, needle, offset) {
      var i = (haystack + '')
        .indexOf(needle, (offset || 0));
      return i === -1 ? false : i;
    };
/* Strrpost */
    cuppa.strrpos = function(haystack, needle, offset) {
      var i = -1;
      if (offset) {
        i = (haystack + '')
          .slice(offset)
          .lastIndexOf(needle);
        if (i !== -1) {
          i += offset;
        }
      } else {
        i = (haystack + '')
          .lastIndexOf(needle);
      }
      return i >= 0 ? i : false;
    };
/* Remove tags */
    cuppa.removeTags = function(input, allowed) {
      allowed = (((allowed || '') + '')
        .toLowerCase()
        .match(/<[a-z][a-z0-9]*>/g) || [])
        .join(''); // making sure the allowed arg is a string containing only tags in lowercase (<a><b><c>)
      var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,
        commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
      return input.replace(commentsAndPhpTags, '')
        .replace(tags, function($0, $1) {
          return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
        });
    };
/* get Filename
    ex: dir/dir/name.txt, return {name:name, ext:txt, type:txt}
*/
    cuppa.getFileDescription = function(file, forced){
        if (!file) return null;
        if(Array.isArray(file)) file = file[0];
		var separator = "/";
        file =  cuppa.replace(file, "\\\\", "/");
        var array = file.split(separator);
		if (cuppa.trim(array[array.length - 1]) === "") array.pop();
        var obj = {};
            obj.name_complete = array.pop();
            obj.path = array.join(separator) + separator;
            obj.file = obj.path + obj.name_complete;
		var array2 = obj.name_complete.split(".");
        if (array2.length > 1 || forced === "file" ) {
			obj.type = "file";
			if (array2.length > 1) obj.extension = array2.pop().toLowerCase();
			else obj.extension = "";
			obj.name = array2.join(".");
		}else{
			obj.type = "folder";
		}
		return obj;
    };
    cuppa.fileDescription = function(filePath){ return cuppa.getFileDescription(filePath); }
/* Convert the \n to <br /> */
    cuppa.nl2br = function(value){
        return value.replace(/\r?\n/g, '<br />');
    };
 /* Convert the <br /> to  \n */
    cuppa.br2nl = function(value){
        return value.replace(/<br\s*[/]?>/gi, "\n");
    };
// JSON Decode
    cuppa.jsonDecode = function(value, base64_decode, opts){
        opts = cuppa.mergeObjects([{removeBreakLines:true, deleteDoubleSpaces:false},opts]);
        if(value === undefined || value === null) return "";
        if(base64_decode === undefined) base64_decode = true;
        if(base64_decode) value = cuppa.base64Decode(value);
        if(opts.removeBreakLines) value = cuppa.removeBreakLines(value);
        if(opts.deleteDoubleSpaces) value = cuppa.deleteDoubleSpaces(value);
        try{ value = JSON.parse(value); }catch(err){};
        return value;
    };
// JSON Encode
    cuppa.jsonEncode = function(value, base64_encode){
        if(value === undefined || value === null) return "";
        if(base64_encode === undefined) base64_encode = true;
        try{ value = JSON.stringify(value); }catch(err){}
        if(base64_encode) value = cuppa.base64Encode(value);
        return value;
    };
// Base64 Decode
    cuppa.base64Decode = function(value){ if(!value) return ''; return Base64.decode(value); };
//  Base64 Encode
    cuppa.base64Encode = function(value){ if(!value) return ''; return Base64.encode(value); };

// URL Encode
    cuppa.urlEncode = function(string){ return encodeURIComponent(string); };
// URL Decode
    cuppa.urlDecode = function(string){ string = cuppa.replace(string, " ", "+"); return decodeURIComponent(string); };
/* Number format */
    cuppa.numberFormat = function(number, decimals, dec_point, thousands_sep) {
      number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
      var n = !isFinite(+number) ? 0 : +number,
        prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
        sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
        dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
        s = '',
        toFixedFix = function (n, prec) {
          var k = Math.pow(10, prec);
          return '' + (Math.round(n * k) / k)
            .toFixed(prec);
        };
      // Fix for IE parseFloat(0.55).toFixed(0) = 0;
          s = (prec ? toFixedFix(n, prec) : '' + Math.round(n))
            .split('.');
          if (s[0].length > 3) {
            s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
          }
          if ((s[1] || '')
            .length < prec) {
            s[1] = s[1] || '';
            s[1] += new Array(prec - s[1].length + 1)
              .join('0');
          }
          return s.join(dec);
    };
// left0
    cuppa.left0 = function(value){
        value = parseFloat(value);
        if(value < 10) value = "0"+ value;
        return value;
    };
// getUUid
    cuppa.uuid = function(){
        var d = new Date().getTime();
        if (typeof performance !== 'undefined' && typeof performance.now === 'function'){
            d += performance.now(); //use high-precision timer if available
        }
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = (d + Math.random() * 16) % 16 | 0;
            d = Math.floor(d / 16);
            return (c === 'x' ? r : (r & 0x3 | 0x8)).toString(16);
        });
    };
    cuppa.getUuid = function(){ return cuppa.uuid(); };
// isUuid
    cuppa.isUuid = function(value){
        if(!value) return false;
        let s = value;
            s = s.match('^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$');
        if (s === null) { return false; }
        return true;
    };
